/*
 * RageIRCd, an advanced Internet Relay Chat daemon (IRCd)
 * include/memory.h: memory management header file
 *
 * Copyright (C) 2002 the past and present IRCd developers, and others.
 * Refer to doc/authors/ for full credits and copyright details.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * $Id: memory.h,v 1.4 2002/11/19 23:16:51 rageircd Exp $
 */

#ifndef __memory_include__
#define __memory_include__

#include "setup.h"
#include "config.h"
#include "blalloc.h"
#include <stdlib.h>
#include <string.h>

extern BlockHeap *local_client_heap;
extern BlockHeap *remote_client_heap;
extern BlockHeap *local_user_heap;
extern BlockHeap *remote_user_heap;
extern BlockHeap *channel_heap;
extern BlockHeap *chanmember_heap;
extern BlockHeap *channelban_heap;
extern BlockHeap *slink_heap;
#ifdef FLUD
extern BlockHeap *fludbot_heap;
#endif
#ifdef HAVE_THROTTLE_ON
extern BlockHeap *throttle_heap;
extern BlockHeap *hashent_heap;
#endif

extern void outofmemory();

extern void *_MyMalloc(size_t, char *, int);
extern void *_MyMallocX(size_t, char *, int);
extern void *_MyRealloc(void *, size_t, char *, int);
extern void _MyFree(void *, char *, int);
extern void _DupString(char **, const char *, char *, int);
extern void *_BlockHeapAlloc(BlockHeap *, char *, int);
extern int _BlockHeapFree(BlockHeap *, void *, char *, int);

#define MyMalloc(x) _MyMalloc(x, __FILE__, __LINE__)
#define MyMallocX(x) _MyMallocX(x, __FILE__, __LINE__)
#define MyRealloc(x, y) _MyRealloc(x, y, __FILE__, __LINE__)
#define MyFree(x) _MyFree(x, __FILE__, __LINE__)
#define DupString(x, y) _DupString(&x, y, __FILE__, __LINE__)
#define BlockHeapAlloc(x) _BlockHeapAlloc(x, __FILE__, __LINE__)
#define BlockHeapFree(x, y) _BlockHeapFree(x, y, __FILE__, __LINE__)

#endif /* __memory_include__ */
